t / test-lib.shon commit test: use $_z40 from test-lib (3749fde)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45unset VISUAL
  46unset GIT_EDITOR
  47unset AUTHOR_DATE
  48unset AUTHOR_EMAIL
  49unset AUTHOR_NAME
  50unset COMMIT_AUTHOR_EMAIL
  51unset COMMIT_AUTHOR_NAME
  52unset EMAIL
  53unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  54unset GIT_AUTHOR_DATE
  55GIT_AUTHOR_EMAIL=author@example.com
  56GIT_AUTHOR_NAME='A U Thor'
  57unset GIT_COMMITTER_DATE
  58GIT_COMMITTER_EMAIL=committer@example.com
  59GIT_COMMITTER_NAME='C O Mitter'
  60unset GIT_DIFF_OPTS
  61unset GIT_DIR
  62unset GIT_WORK_TREE
  63unset GIT_EXTERNAL_DIFF
  64unset GIT_INDEX_FILE
  65unset GIT_OBJECT_DIRECTORY
  66unset GIT_CEILING_DIRECTORIES
  67unset SHA1_FILE_DIRECTORIES
  68unset SHA1_FILE_DIRECTORY
  69unset GIT_NOTES_REF
  70unset GIT_NOTES_DISPLAY_REF
  71unset GIT_NOTES_REWRITE_REF
  72unset GIT_NOTES_REWRITE_MODE
  73GIT_MERGE_VERBOSITY=5
  74export GIT_MERGE_VERBOSITY
  75export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  76export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  77export EDITOR
  78
  79# Protect ourselves from common misconfiguration to export
  80# CDPATH into the environment
  81unset CDPATH
  82
  83unset GREP_OPTIONS
  84
  85case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  86        1|2|true)
  87                echo "* warning: Some tests will not work if GIT_TRACE" \
  88                        "is set as to trace on STDERR ! *"
  89                echo "* warning: Please set GIT_TRACE to something" \
  90                        "other than 1, 2 or true ! *"
  91                ;;
  92esac
  93
  94# Convenience
  95#
  96# A regexp to match 5 and 40 hexdigits
  97_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  98_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  99
 100# Zero SHA-1
 101_z40=0000000000000000000000000000000000000000
 102
 103# Each test should start with something like this, after copyright notices:
 104#
 105# test_description='Description of this test...
 106# This test checks if command xyzzy does the right thing...
 107# '
 108# . ./test-lib.sh
 109[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 110                TERM=$ORIGINAL_TERM &&
 111                export TERM &&
 112                [ -t 1 ] &&
 113                tput bold >/dev/null 2>&1 &&
 114                tput setaf 1 >/dev/null 2>&1 &&
 115                tput sgr0 >/dev/null 2>&1
 116        ) &&
 117        color=t
 118
 119while test "$#" -ne 0
 120do
 121        case "$1" in
 122        -d|--d|--de|--deb|--debu|--debug)
 123                debug=t; shift ;;
 124        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 125                immediate=t; shift ;;
 126        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 127                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 128        -h|--h|--he|--hel|--help)
 129                help=t; shift ;;
 130        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 131                verbose=t; shift ;;
 132        -q|--q|--qu|--qui|--quie|--quiet)
 133                # Ignore --quiet under a TAP::Harness. Saying how many tests
 134                # passed without the ok/not ok details is always an error.
 135                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 136        --with-dashes)
 137                with_dashes=t; shift ;;
 138        --no-color)
 139                color=; shift ;;
 140        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 141                valgrind=t; verbose=t; shift ;;
 142        --tee)
 143                shift ;; # was handled already
 144        --root=*)
 145                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 146                shift ;;
 147        *)
 148                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 149        esac
 150done
 151
 152if test -n "$color"; then
 153        say_color () {
 154                (
 155                TERM=$ORIGINAL_TERM
 156                export TERM
 157                case "$1" in
 158                        error) tput bold; tput setaf 1;; # bold red
 159                        skip)  tput bold; tput setaf 2;; # bold green
 160                        pass)  tput setaf 2;;            # green
 161                        info)  tput setaf 3;;            # brown
 162                        *) test -n "$quiet" && return;;
 163                esac
 164                shift
 165                printf "%s" "$*"
 166                tput sgr0
 167                echo
 168                )
 169        }
 170else
 171        say_color() {
 172                test -z "$1" && test -n "$quiet" && return
 173                shift
 174                echo "$*"
 175        }
 176fi
 177
 178error () {
 179        say_color error "error: $*"
 180        GIT_EXIT_OK=t
 181        exit 1
 182}
 183
 184say () {
 185        say_color info "$*"
 186}
 187
 188test "${test_description}" != "" ||
 189error "Test script did not set test_description."
 190
 191if test "$help" = "t"
 192then
 193        echo "$test_description"
 194        exit 0
 195fi
 196
 197exec 5>&1
 198if test "$verbose" = "t"
 199then
 200        exec 4>&2 3>&1
 201else
 202        exec 4>/dev/null 3>/dev/null
 203fi
 204
 205test_failure=0
 206test_count=0
 207test_fixed=0
 208test_broken=0
 209test_success=0
 210
 211test_external_has_tap=0
 212
 213die () {
 214        code=$?
 215        if test -n "$GIT_EXIT_OK"
 216        then
 217                exit $code
 218        else
 219                echo >&5 "FATAL: Unexpected exit with code $code"
 220                exit 1
 221        fi
 222}
 223
 224GIT_EXIT_OK=
 225trap 'die' EXIT
 226
 227# The semantics of the editor variables are that of invoking
 228# sh -c "$EDITOR \"$@\"" files ...
 229#
 230# If our trash directory contains shell metacharacters, they will be
 231# interpreted if we just set $EDITOR directly, so do a little dance with
 232# environment variables to work around this.
 233#
 234# In particular, quoting isn't enough, as the path may contain the same quote
 235# that we're using.
 236test_set_editor () {
 237        FAKE_EDITOR="$1"
 238        export FAKE_EDITOR
 239        EDITOR='"$FAKE_EDITOR"'
 240        export EDITOR
 241}
 242
 243test_decode_color () {
 244        sed     -e 's/.\[1m/<WHITE>/g' \
 245                -e 's/.\[31m/<RED>/g' \
 246                -e 's/.\[32m/<GREEN>/g' \
 247                -e 's/.\[33m/<YELLOW>/g' \
 248                -e 's/.\[34m/<BLUE>/g' \
 249                -e 's/.\[35m/<MAGENTA>/g' \
 250                -e 's/.\[36m/<CYAN>/g' \
 251                -e 's/.\[m/<RESET>/g'
 252}
 253
 254q_to_nul () {
 255        perl -pe 'y/Q/\000/'
 256}
 257
 258q_to_cr () {
 259        tr Q '\015'
 260}
 261
 262q_to_tab () {
 263        tr Q '\011'
 264}
 265
 266append_cr () {
 267        sed -e 's/$/Q/' | tr Q '\015'
 268}
 269
 270remove_cr () {
 271        tr '\015' Q | sed -e 's/Q$//'
 272}
 273
 274test_tick () {
 275        if test -z "${test_tick+set}"
 276        then
 277                test_tick=1112911993
 278        else
 279                test_tick=$(($test_tick + 60))
 280        fi
 281        GIT_COMMITTER_DATE="$test_tick -0700"
 282        GIT_AUTHOR_DATE="$test_tick -0700"
 283        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 284}
 285
 286# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 287#
 288# This will commit a file with the given contents and the given commit
 289# message.  It will also add a tag with <message> as name.
 290#
 291# Both <file> and <contents> default to <message>.
 292
 293test_commit () {
 294        file=${2:-"$1.t"}
 295        echo "${3-$1}" > "$file" &&
 296        git add "$file" &&
 297        test_tick &&
 298        git commit -m "$1" &&
 299        git tag "$1"
 300}
 301
 302# Call test_merge with the arguments "<message> <commit>", where <commit>
 303# can be a tag pointing to the commit-to-merge.
 304
 305test_merge () {
 306        test_tick &&
 307        git merge -m "$1" "$2" &&
 308        git tag "$1"
 309}
 310
 311# This function helps systems where core.filemode=false is set.
 312# Use it instead of plain 'chmod +x' to set or unset the executable bit
 313# of a file in the working directory and add it to the index.
 314
 315test_chmod () {
 316        chmod "$@" &&
 317        git update-index --add "--chmod=$@"
 318}
 319
 320# Use test_set_prereq to tell that a particular prerequisite is available.
 321# The prerequisite can later be checked for in two ways:
 322#
 323# - Explicitly using test_have_prereq.
 324#
 325# - Implicitly by specifying the prerequisite tag in the calls to
 326#   test_expect_{success,failure,code}.
 327#
 328# The single parameter is the prerequisite tag (a simple word, in all
 329# capital letters by convention).
 330
 331test_set_prereq () {
 332        satisfied="$satisfied$1 "
 333}
 334satisfied=" "
 335
 336test_have_prereq () {
 337        # prerequisites can be concatenated with ','
 338        save_IFS=$IFS
 339        IFS=,
 340        set -- $*
 341        IFS=$save_IFS
 342
 343        total_prereq=0
 344        ok_prereq=0
 345        missing_prereq=
 346
 347        for prerequisite
 348        do
 349                total_prereq=$(($total_prereq + 1))
 350                case $satisfied in
 351                *" $prerequisite "*)
 352                        ok_prereq=$(($ok_prereq + 1))
 353                        ;;
 354                *)
 355                        # Keep a list of missing prerequisites
 356                        if test -z "$missing_prereq"
 357                        then
 358                                missing_prereq=$prerequisite
 359                        else
 360                                missing_prereq="$prerequisite,$missing_prereq"
 361                        fi
 362                esac
 363        done
 364
 365        test $total_prereq = $ok_prereq
 366}
 367
 368# You are not expected to call test_ok_ and test_failure_ directly, use
 369# the text_expect_* functions instead.
 370
 371test_ok_ () {
 372        test_success=$(($test_success + 1))
 373        say_color "" "ok $test_count - $@"
 374}
 375
 376test_failure_ () {
 377        test_failure=$(($test_failure + 1))
 378        say_color error "not ok - $test_count $1"
 379        shift
 380        echo "$@" | sed -e 's/^/#       /'
 381        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 382}
 383
 384test_known_broken_ok_ () {
 385        test_fixed=$(($test_fixed+1))
 386        say_color "" "ok $test_count - $@ # TODO known breakage"
 387}
 388
 389test_known_broken_failure_ () {
 390        test_broken=$(($test_broken+1))
 391        say_color skip "not ok $test_count - $@ # TODO known breakage"
 392}
 393
 394test_debug () {
 395        test "$debug" = "" || eval "$1"
 396}
 397
 398test_run_ () {
 399        test_cleanup=:
 400        eval >&3 2>&4 "$1"
 401        eval_ret=$?
 402        eval >&3 2>&4 "$test_cleanup"
 403        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 404                echo ""
 405        fi
 406        return 0
 407}
 408
 409test_skip () {
 410        test_count=$(($test_count+1))
 411        to_skip=
 412        for skp in $GIT_SKIP_TESTS
 413        do
 414                case $this_test.$test_count in
 415                $skp)
 416                        to_skip=t
 417                        break
 418                esac
 419        done
 420        if test -z "$to_skip" && test -n "$prereq" &&
 421           ! test_have_prereq "$prereq"
 422        then
 423                to_skip=t
 424        fi
 425        case "$to_skip" in
 426        t)
 427                of_prereq=
 428                if test "$missing_prereq" != "$prereq"
 429                then
 430                        of_prereq=" of $prereq"
 431                fi
 432
 433                say_color skip >&3 "skipping test: $@"
 434                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 435                : true
 436                ;;
 437        *)
 438                false
 439                ;;
 440        esac
 441}
 442
 443test_expect_failure () {
 444        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 445        test "$#" = 2 ||
 446        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 447        if ! test_skip "$@"
 448        then
 449                say >&3 "checking known breakage: $2"
 450                test_run_ "$2"
 451                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 452                then
 453                        test_known_broken_ok_ "$1"
 454                else
 455                        test_known_broken_failure_ "$1"
 456                fi
 457        fi
 458        echo >&3 ""
 459}
 460
 461test_expect_success () {
 462        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 463        test "$#" = 2 ||
 464        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 465        if ! test_skip "$@"
 466        then
 467                say >&3 "expecting success: $2"
 468                test_run_ "$2"
 469                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 470                then
 471                        test_ok_ "$1"
 472                else
 473                        test_failure_ "$@"
 474                fi
 475        fi
 476        echo >&3 ""
 477}
 478
 479test_expect_code () {
 480        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 481        test "$#" = 3 ||
 482        error "bug in the test script: not 3 or 4 parameters to test-expect-code"
 483        if ! test_skip "$@"
 484        then
 485                say >&3 "expecting exit code $1: $3"
 486                test_run_ "$3"
 487                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
 488                then
 489                        test_ok_ "$2"
 490                else
 491                        test_failure_ "$@"
 492                fi
 493        fi
 494        echo >&3 ""
 495}
 496
 497# test_external runs external test scripts that provide continuous
 498# test output about their progress, and succeeds/fails on
 499# zero/non-zero exit code.  It outputs the test output on stdout even
 500# in non-verbose mode, and announces the external script with "# run
 501# <n>: ..." before running it.  When providing relative paths, keep in
 502# mind that all scripts run in "trash directory".
 503# Usage: test_external description command arguments...
 504# Example: test_external 'Perl API' perl ../path/to/test.pl
 505test_external () {
 506        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 507        test "$#" = 3 ||
 508        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 509        descr="$1"
 510        shift
 511        if ! test_skip "$descr" "$@"
 512        then
 513                # Announce the script to reduce confusion about the
 514                # test output that follows.
 515                say_color "" "# run $test_count: $descr ($*)"
 516                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 517                # to be able to use them in script
 518                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 519                # Run command; redirect its stderr to &4 as in
 520                # test_run_, but keep its stdout on our stdout even in
 521                # non-verbose mode.
 522                "$@" 2>&4
 523                if [ "$?" = 0 ]
 524                then
 525                        if test $test_external_has_tap -eq 0; then
 526                                test_ok_ "$descr"
 527                        else
 528                                say_color "" "# test_external test $descr was ok"
 529                                test_success=$(($test_success + 1))
 530                        fi
 531                else
 532                        if test $test_external_has_tap -eq 0; then
 533                                test_failure_ "$descr" "$@"
 534                        else
 535                                say_color error "# test_external test $descr failed: $@"
 536                                test_failure=$(($test_failure + 1))
 537                        fi
 538                fi
 539        fi
 540}
 541
 542# Like test_external, but in addition tests that the command generated
 543# no output on stderr.
 544test_external_without_stderr () {
 545        # The temporary file has no (and must have no) security
 546        # implications.
 547        tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
 548        stderr="$tmp/git-external-stderr.$$.tmp"
 549        test_external "$@" 4> "$stderr"
 550        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 551        descr="no stderr: $1"
 552        shift
 553        say >&3 "# expecting no stderr from previous command"
 554        if [ ! -s "$stderr" ]; then
 555                rm "$stderr"
 556
 557                if test $test_external_has_tap -eq 0; then
 558                        test_ok_ "$descr"
 559                else
 560                        say_color "" "# test_external_without_stderr test $descr was ok"
 561                        test_success=$(($test_success + 1))
 562                fi
 563        else
 564                if [ "$verbose" = t ]; then
 565                        output=`echo; echo "# Stderr is:"; cat "$stderr"`
 566                else
 567                        output=
 568                fi
 569                # rm first in case test_failure exits.
 570                rm "$stderr"
 571                if test $test_external_has_tap -eq 0; then
 572                        test_failure_ "$descr" "$@" "$output"
 573                else
 574                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 575                        test_failure=$(($test_failure + 1))
 576                fi
 577        fi
 578}
 579
 580# debugging-friendly alternatives to "test [-f|-d|-e]"
 581# The commands test the existence or non-existence of $1. $2 can be
 582# given to provide a more precise diagnosis.
 583test_path_is_file () {
 584        if ! [ -f "$1" ]
 585        then
 586                echo "File $1 doesn't exist. $*"
 587                false
 588        fi
 589}
 590
 591test_path_is_dir () {
 592        if ! [ -d "$1" ]
 593        then
 594                echo "Directory $1 doesn't exist. $*"
 595                false
 596        fi
 597}
 598
 599test_path_is_missing () {
 600        if [ -e "$1" ]
 601        then
 602                echo "Path exists:"
 603                ls -ld "$1"
 604                if [ $# -ge 1 ]; then
 605                        echo "$*"
 606                fi
 607                false
 608        fi
 609}
 610
 611
 612# This is not among top-level (test_expect_success | test_expect_failure)
 613# but is a prefix that can be used in the test script, like:
 614#
 615#       test_expect_success 'complain and die' '
 616#           do something &&
 617#           do something else &&
 618#           test_must_fail git checkout ../outerspace
 619#       '
 620#
 621# Writing this as "! git checkout ../outerspace" is wrong, because
 622# the failure could be due to a segv.  We want a controlled failure.
 623
 624test_must_fail () {
 625        "$@"
 626        exit_code=$?
 627        if test $exit_code = 0; then
 628                echo >&2 "test_must_fail: command succeeded: $*"
 629                return 1
 630        elif test $exit_code -gt 129 -a $exit_code -le 192; then
 631                echo >&2 "test_must_fail: died by signal: $*"
 632                return 1
 633        elif test $exit_code = 127; then
 634                echo >&2 "test_must_fail: command not found: $*"
 635                return 1
 636        fi
 637        return 0
 638}
 639
 640# Similar to test_must_fail, but tolerates success, too.  This is
 641# meant to be used in contexts like:
 642#
 643#       test_expect_success 'some command works without configuration' '
 644#               test_might_fail git config --unset all.configuration &&
 645#               do something
 646#       '
 647#
 648# Writing "git config --unset all.configuration || :" would be wrong,
 649# because we want to notice if it fails due to segv.
 650
 651test_might_fail () {
 652        "$@"
 653        exit_code=$?
 654        if test $exit_code -gt 129 -a $exit_code -le 192; then
 655                echo >&2 "test_might_fail: died by signal: $*"
 656                return 1
 657        elif test $exit_code = 127; then
 658                echo >&2 "test_might_fail: command not found: $*"
 659                return 1
 660        fi
 661        return 0
 662}
 663
 664# test_cmp is a helper function to compare actual and expected output.
 665# You can use it like:
 666#
 667#       test_expect_success 'foo works' '
 668#               echo expected >expected &&
 669#               foo >actual &&
 670#               test_cmp expected actual
 671#       '
 672#
 673# This could be written as either "cmp" or "diff -u", but:
 674# - cmp's output is not nearly as easy to read as diff -u
 675# - not all diff versions understand "-u"
 676
 677test_cmp() {
 678        $GIT_TEST_CMP "$@"
 679}
 680
 681# This function can be used to schedule some commands to be run
 682# unconditionally at the end of the test to restore sanity:
 683#
 684#       test_expect_success 'test core.capslock' '
 685#               git config core.capslock true &&
 686#               test_when_finished "git config --unset core.capslock" &&
 687#               hello world
 688#       '
 689#
 690# That would be roughly equivalent to
 691#
 692#       test_expect_success 'test core.capslock' '
 693#               git config core.capslock true &&
 694#               hello world
 695#               git config --unset core.capslock
 696#       '
 697#
 698# except that the greeting and config --unset must both succeed for
 699# the test to pass.
 700
 701test_when_finished () {
 702        test_cleanup="{ $*
 703                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 704}
 705
 706# Most tests can use the created repository, but some may need to create more.
 707# Usage: test_create_repo <directory>
 708test_create_repo () {
 709        test "$#" = 1 ||
 710        error "bug in the test script: not 1 parameter to test-create-repo"
 711        repo="$1"
 712        mkdir -p "$repo"
 713        (
 714                cd "$repo" || error "Cannot setup test environment"
 715                "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 716                error "cannot run git init -- have you built things yet?"
 717                mv .git/hooks .git/hooks-disabled
 718        ) || exit
 719}
 720
 721test_done () {
 722        GIT_EXIT_OK=t
 723
 724        if test -z "$HARNESS_ACTIVE"; then
 725                test_results_dir="$TEST_DIRECTORY/test-results"
 726                mkdir -p "$test_results_dir"
 727                test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 728
 729                echo "total $test_count" >> $test_results_path
 730                echo "success $test_success" >> $test_results_path
 731                echo "fixed $test_fixed" >> $test_results_path
 732                echo "broken $test_broken" >> $test_results_path
 733                echo "failed $test_failure" >> $test_results_path
 734                echo "" >> $test_results_path
 735        fi
 736
 737        if test "$test_fixed" != 0
 738        then
 739                say_color pass "# fixed $test_fixed known breakage(s)"
 740        fi
 741        if test "$test_broken" != 0
 742        then
 743                say_color error "# still have $test_broken known breakage(s)"
 744                msg="remaining $(($test_count-$test_broken)) test(s)"
 745        else
 746                msg="$test_count test(s)"
 747        fi
 748        case "$test_failure" in
 749        0)
 750                # Maybe print SKIP message
 751                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 752
 753                if test $test_external_has_tap -eq 0; then
 754                        say_color pass "# passed all $msg"
 755                        say "1..$test_count$skip_all"
 756                fi
 757
 758                test -d "$remove_trash" &&
 759                cd "$(dirname "$remove_trash")" &&
 760                rm -rf "$(basename "$remove_trash")"
 761
 762                exit 0 ;;
 763
 764        *)
 765                if test $test_external_has_tap -eq 0; then
 766                        say_color error "# failed $test_failure among $msg"
 767                        say "1..$test_count"
 768                fi
 769
 770                exit 1 ;;
 771
 772        esac
 773}
 774
 775# Test the binaries we have just built.  The tests are kept in
 776# t/ subdirectory and are run in 'trash directory' subdirectory.
 777if test -z "$TEST_DIRECTORY"
 778then
 779        # We allow tests to override this, in case they want to run tests
 780        # outside of t/, e.g. for running tests on the test library
 781        # itself.
 782        TEST_DIRECTORY=$(pwd)
 783fi
 784GIT_BUILD_DIR="$TEST_DIRECTORY"/..
 785
 786if test -n "$valgrind"
 787then
 788        make_symlink () {
 789                test -h "$2" &&
 790                test "$1" = "$(readlink "$2")" || {
 791                        # be super paranoid
 792                        if mkdir "$2".lock
 793                        then
 794                                rm -f "$2" &&
 795                                ln -s "$1" "$2" &&
 796                                rm -r "$2".lock
 797                        else
 798                                while test -d "$2".lock
 799                                do
 800                                        say "Waiting for lock on $2."
 801                                        sleep 1
 802                                done
 803                        fi
 804                }
 805        }
 806
 807        make_valgrind_symlink () {
 808                # handle only executables
 809                test -x "$1" || return
 810
 811                base=$(basename "$1")
 812                symlink_target=$GIT_BUILD_DIR/$base
 813                # do not override scripts
 814                if test -x "$symlink_target" &&
 815                    test ! -d "$symlink_target" &&
 816                    test "#!" != "$(head -c 2 < "$symlink_target")"
 817                then
 818                        symlink_target=../valgrind.sh
 819                fi
 820                case "$base" in
 821                *.sh|*.perl)
 822                        symlink_target=../unprocessed-script
 823                esac
 824                # create the link, or replace it if it is out of date
 825                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 826        }
 827
 828        # override all git executables in TEST_DIRECTORY/..
 829        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 830        mkdir -p "$GIT_VALGRIND"/bin
 831        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 832        do
 833                make_valgrind_symlink $file
 834        done
 835        OLDIFS=$IFS
 836        IFS=:
 837        for path in $PATH
 838        do
 839                ls "$path"/git-* 2> /dev/null |
 840                while read file
 841                do
 842                        make_valgrind_symlink "$file"
 843                done
 844        done
 845        IFS=$OLDIFS
 846        PATH=$GIT_VALGRIND/bin:$PATH
 847        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 848        export GIT_VALGRIND
 849elif test -n "$GIT_TEST_INSTALLED" ; then
 850        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 851        error "Cannot run git from $GIT_TEST_INSTALLED."
 852        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 853        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 854else # normal case, use ../bin-wrappers only unless $with_dashes:
 855        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 856        if ! test -x "$git_bin_dir/git" ; then
 857                if test -z "$with_dashes" ; then
 858                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 859                fi
 860                with_dashes=t
 861        fi
 862        PATH="$git_bin_dir:$PATH"
 863        GIT_EXEC_PATH=$GIT_BUILD_DIR
 864        if test -n "$with_dashes" ; then
 865                PATH="$GIT_BUILD_DIR:$PATH"
 866        fi
 867fi
 868GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 869unset GIT_CONFIG
 870GIT_CONFIG_NOSYSTEM=1
 871GIT_CONFIG_NOGLOBAL=1
 872export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
 873
 874. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
 875
 876if test -z "$GIT_TEST_CMP"
 877then
 878        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 879        then
 880                GIT_TEST_CMP="$DIFF -c"
 881        else
 882                GIT_TEST_CMP="$DIFF -u"
 883        fi
 884fi
 885
 886GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 887export GITPERLLIB
 888test -d "$GIT_BUILD_DIR"/templates/blt || {
 889        error "You haven't built things yet, have you?"
 890}
 891
 892if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 893then
 894        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
 895        export GITPYTHONLIB
 896        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
 897                error "You haven't built git_remote_helpers yet, have you?"
 898        }
 899fi
 900
 901if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
 902        echo >&2 'You need to build test-chmtime:'
 903        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 904        exit 1
 905fi
 906
 907# Test repository
 908test="trash directory.$(basename "$0" .sh)"
 909test -n "$root" && test="$root/$test"
 910case "$test" in
 911/*) TRASH_DIRECTORY="$test" ;;
 912 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
 913esac
 914test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 915rm -fr "$test" || {
 916        GIT_EXIT_OK=t
 917        echo >&5 "FATAL: Cannot prepare test area"
 918        exit 1
 919}
 920
 921test_create_repo "$test"
 922# Use -P to resolve symlinks in our working directory so that the cwd
 923# in subprocesses like git equals our $PWD (for pathname comparisons).
 924cd -P "$test" || exit 1
 925
 926HOME=$(pwd)
 927export HOME
 928
 929this_test=${0##*/}
 930this_test=${this_test%%-*}
 931for skp in $GIT_SKIP_TESTS
 932do
 933        case "$this_test" in
 934        $skp)
 935                say_color skip >&3 "skipping test $this_test altogether"
 936                skip_all="skip all tests in $this_test"
 937                test_done
 938        esac
 939done
 940
 941# Provide an implementation of the 'yes' utility
 942yes () {
 943        if test $# = 0
 944        then
 945                y=y
 946        else
 947                y="$*"
 948        fi
 949
 950        while echo "$y"
 951        do
 952                :
 953        done
 954}
 955
 956# Fix some commands on Windows
 957case $(uname -s) in
 958*MINGW*)
 959        # Windows has its own (incompatible) sort and find
 960        sort () {
 961                /usr/bin/sort "$@"
 962        }
 963        find () {
 964                /usr/bin/find "$@"
 965        }
 966        sum () {
 967                md5sum "$@"
 968        }
 969        # git sees Windows-style pwd
 970        pwd () {
 971                builtin pwd -W
 972        }
 973        # no POSIX permissions
 974        # backslashes in pathspec are converted to '/'
 975        # exec does not inherit the PID
 976        ;;
 977*)
 978        test_set_prereq POSIXPERM
 979        test_set_prereq BSLASHPSPEC
 980        test_set_prereq EXECKEEPSPID
 981        ;;
 982esac
 983
 984test -z "$NO_PERL" && test_set_prereq PERL
 985test -z "$NO_PYTHON" && test_set_prereq PYTHON
 986
 987# test whether the filesystem supports symbolic links
 988ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
 989rm -f y
 990
 991# When the tests are run as root, permission tests will report that
 992# things are writable when they shouldn't be.
 993test -w / || test_set_prereq SANITY